#!/bin/sh
if [ -n "$1" ]; then
	SDBDIR=$1
else
	SDBDIR="/usr/local/sdb"
fi
BINDIR="${SDBDIR}/bin"
HTMLDIR="${SDBDIR}/http"
BKOPT="-b -S .bak"

install -d $SDBDIR
install -d $SDBDIR/etc
install -d $SDBDIR/log
install -d $SDBDIR/tools
install -d $HTMLDIR
install -d $HTMLDIR/phplib
install -d $HTMLDIR/manual
install -d $HTMLDIR/manual/img

install $BKOPT -m 0644 sample/sdb-linux.def $SDBDIR/etc/sdb.def

for i in web/http/*.php ; do
	if [ -f $i ]; then
		install -m 0644 $i $HTMLDIR
	fi
done;

for i in phplib/*.inc ; do
	if [ -f $i ]; then
		install $BKOPT -m 0644 $i $HTMLDIR/phplib
	fi
done;

for i in manual/*.htm ; do
	if [ -f $i ]; then
		install $BKOPT -m 0644 $i $HTMLDIR/manual
	fi
done;

for i in manual/img/*.* ; do
	if [ -f $i ]; then
		install $BKOPT -m 0644 $i $HTMLDIR/manual/img
	fi
done;

for i in tools/*; do
	if [ -f $i ]; then
		install $BKOPT -m 0644 $i $SDBDIR/tools
	fi
done;
