//////////////////////////////////////////////////////////////////////////
//	"sqarg.cpp"
//------------------------------------------------------------------------
//	$Id: sqarg.cpp 87 2006-03-30 09:24:05Z taro $
//////////////////////////////////////////////////////////////////////////

#include	"sqarg.h"
#if	defined(WIN32)
# include	<windows.h>
#else
# include	"../linux/defs.h"
# include	<stdlib.h>
# include	<ctype.h>
# include	<string.h>
#endif

SQArg::SQArg()
{
	argc = 0;
	argv = NULL;
}

SQArg::~SQArg()
{
	clear();
}

int		SQArg::setCmdline(const TCHAR *s)
{
	if ( cmdline.SetText(s) == NULL )
		return -1;
	return 0;
}

int		SQArg::getArgs(int & newargc, TCHAR **& newargv, const TCHAR *s)
{
	newargc = 0;
	newargv = NULL;
	if ( setCmdline(s) < 0 )
		return -1;
	if ( getArgs() < 0 )
		return -1;
	newargc = argc;
	newargv = argv;
	return 0;
}

int		SQArg::getArgs(void)
{
	int			i, j, k;
	TCHAR *		buff;
	int			ch;
	int			top_flg = TRUE;
	int			cma_flg = FALSE;    // ',' flag
	TCHAR *		strBuf;
	TCHAR *		s;

	if ( argv != NULL )
		clear();
	argc = 0;
	if ( (s = cmdline.GetText()) == NULL || cmdline.GetLength() == 0 )
		return (-1);
	if ( (i = (int)_tcslen(s)) == 0 )
		return (-1);

	if ( (strBuf = new TCHAR [i + 1]) == NULL )
		return (-1);
	buff = strBuf;

	do
	{
#define next_arg()  { ++argc; *buff++ = TEXT('\0'); goto _NEXT_CHAR; }

		if( top_flg )
		{
			do
			{
				ch = *(TCHAR *)s++;
			} while ( _istspace(ch) );
			switch ( ch )
			{
				case TEXT('\0'):
					if ( cma_flg )
						next_arg();
					break;
				case TEXT(','):
					if ( cma_flg )
						next_arg();
					cma_flg = TRUE;
					break;
                case TEXT('"'):
                    for (;;)
                    {
                        ch = *(TCHAR *)s++;
                        if ( ch == TEXT('\0') || ch == TEXT('"') )
                            break;
                        *buff++ = ch;
                    }
                    next_arg();
                default:
                    *buff++ = ch;
                    top_flg = FALSE;
                    cma_flg = FALSE;
                    break;
            }
        } else
        {
            ch = *(TCHAR *)s++;
            if ( ch == '\0' )
                next_arg();
            cma_flg = FALSE;
            if ( _istspace(ch) )
            {
                top_flg = TRUE;
                next_arg();
            } else if ( ch == TEXT(',') )
            {
                cma_flg = TRUE;
                top_flg = TRUE;
                next_arg();
            } else
                *buff++ = ch;
        }
_NEXT_CHAR:
        ;
#undef  next_arg
    } while ( ch );

    if ( argc == 0 || (argv = new TCHAR * [argc + 1]) == NULL )
    {
        delete [] strBuf;
        return (-1);
    }
    for ( i = j = k = 0; (unsigned)k <= (unsigned)(buff - strBuf); ++k )
    {
        if ( strBuf[k] == TEXT('\0') )
        {
            if ( (argv[i] = new TCHAR [_tcslen(&strBuf[j]) + 1]) == NULL )
            {
                while ( --i >= 0 )
                    delete [] argv[i];
                delete [] argv;
                delete [] strBuf;
                return -1;
            }
            _tcscpy( argv[i], &strBuf[j] );
            ++i;
            if ( i >= argc )
            {
                argv[argc] = NULL;
                break;
            }
            j = k + 1;
        }
    }
    delete [] strBuf;

    return (0);
}

void	SQArg::clear(void)
{
	if ( argv != NULL )
	{
		if ( argc > 0 )
		{
			while ( --argc >= 0 )
				delete [] argv[argc];
		}
		delete [] argv;
		argv = NULL;
	}
	argc = 0;
}
