//////////////////////////////////////////////////////////////////////////
//	"sqpath.h"
//------------------------------------------------------------------------
//	$Id: sqpath.h 21 2006-03-04 08:46:09Z taro $
//////////////////////////////////////////////////////////////////////////

#ifndef	SQPATH_H_INCLUDED
#define	SQPATH_H_INCLUDED

#include	"sqstr.h"
#if	defined(WIN32)
#elif	defined(LINUX)
# include	"../linux/defs.h"
# include	<string.h>
#endif

#ifndef	SQPATH_DEFAULT_DELIM
#if	defined(WIN32)
# define	SQPATH_DEFAULT_DELIM	TEXT("\\/")
#else
# define	SQPATH_DEFAULT_DELIM	TEXT("/\\")
#endif
#endif

class SQPath : public SQStr
{
private:
	static TCHAR	delimBuf[32];
	TCHAR *			delim;			// pX̋؂蕶

public:
	SQPath();
	~SQPath();

	static int		SetDefDelim(const TCHAR *s) { _tcsncpy(SQPath::delimBuf, s, sizeof(delimBuf)/sizeof(*delimBuf)); return 0; }
	static TCHAR *	GetDefDelim(void) { return SQPath::delimBuf; }
	int				GetDelimCh(void) { return (int)*delim; }
	int				IsDelim(int ch)
	{	const TCHAR *	dp;
		for ( dp = this->delim; *dp; ++dp )
			if ( *dp == ch )
				return 1;
		return 0;
	}

	SQStr &		AddPath(SQStr & s2);
	SQStr &		AddPath(const TCHAR *s2) { SQStr ss2 = s2; return this->AddPath(ss2); };
	SQStr &		AddPath(SQStr & s1, SQStr & s2) { this->SetText(s1.GetText()); return this->AddPath(s2);}
	SQStr & 	AddPath(const TCHAR *s1, const TCHAR *s2) { SQStr ss1 = s1, ss2 = s2; return this->AddPath(ss1,ss2);}
	SQStr & 	GetFn(SQStr & s2);
	SQStr & 	GetFn(const TCHAR *s2) { SQStr ss2 = s2; return GetFn(ss2);}
	SQStr &		GetSn(SQStr & s2);
	SQStr & 	GetSn(const TCHAR *s2) { SQStr ss2 = s2; return GetSn(ss2);}
	SQStr &		GetDnam(SQStr & s2);
	SQStr & 	GetDnam(const TCHAR *s2) { SQStr ss2 = s2; return GetDnam(ss2);}
	SQStr &		GetFnam(SQStr & s2);
	SQStr &		GetFnam(const TCHAR * s2) { SQStr ss2 = s2; return GetFnam(ss2); }
};

#endif
