/////////////////////////////////////////////////////////////////////////
//	"sdb_dbdrop.cpp"
//------------------------------------------------------------------------
//	$Id: sdb_dbdrop.cpp 25 2006-03-04 14:55:30Z taro $
//////////////////////////////////////////////////////////////////////////

#include	"../include/sdblib.h"
#if	defined(WIN32)
# include	<crtdbg.h>
#endif

#if	defined(_DEBUG) && defined(WIN32)
#	define	DBGREPORT(param_)	_CrtDbgReport param_
#else
#	define	DBGREPORT(param_)
# ifndef	_ASSERT
#	define	_ASSERT
# endif
#endif

int		SdbLib::DBDrop(void)
{
	SqlLib				*sqllib = this->sqllib;
	sdb::DBDevDataList	devlist;
	int					ret = 0;

	DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"SdbLib::DBDrop()\n"));
	_ASSERT(sqllib != NULL);
	if ( sqllib->IsConnect() == FALSE )
		return -1;
	if ( this->dbdev.tblname.GetLength() == 0 )
		return -1;

	sqllib->Begin();
	if ( this->dbdev.GetDevDataList(devlist) < 0 )
		ret = -1;
	if ( ret == 0 )
	{
		sdb::DBDevDataList::iterator	it;
		SdbDev							*dev;

		if ( (dev = this->CreateSdbDev()) == NULL )
			ret = -1;
		if  ( ret == 0 )
		{
			for ( it = devlist.begin(); it != devlist.end(); it++ )
			{
				sdb::DBDevData	devdata;

				devdata = *it;
#if	defined(SDBCTL)
				_ftprintf(stderr, TEXT("(%3d) Model %s, Serial %s, table %s \n")
				  , devdata.dev_id
				  , devdata.dev_model.GetDisplayText()
				  , devdata.dev_serial.GetDisplayText()
				  , devdata.dev_smt_tblname.GetDisplayText()
				 );
#endif
				if ( devdata.dev_smt_tblname.GetLength() > 0 )
				{	// e[u
					_ASSERT(dev->dbsmt != NULL );
					dev->dbsmt->tblname.SetText(devdata.dev_smt_tblname);
					if ( dev->dbsmt->DropTable() < 0 )
					{	// drop error
						TCHAR				sql[1024], where[256];
						SqlLib::Result		sqlres;

						_stprintf(where, TEXT("%s=%d"), sdb::smt_tbl[sdb::SMT_DEV_ID].fname, devdata.dev_id);
						_stprintf(sql, TEXT("SELECT count(%s) FROM %s WHERE %s")
						  , sdb::smt_tbl[sdb::SMT_DEV_ID].fname
						  , dev->dbsmt->tblname.GetText()
						  , where );
						if ( sqllib->Exec(sqlres, sql) < 0 || sqllib->GetStatus(sqlres) != SqlLib::RES_OK )
						{	// error
						} else
						{
							if ( sqllib->GetTuples(sqlres) > 0 && sqllib->GetFields(sqlres) > 0 )
							{	// ܂f[^cĂ̂ŃG[
#if	defined(SDBCTL)
								_ftprintf(stderr, TEXT("Drop table error! (%s)\n")
								  , dev->dbsmt->tblname.GetDisplayText()
								);
#endif
								ret = -1;
							}
						}
						sqllib->ClearResult(sqlres);
					}
				}
				if ( ret < 0 )
					break;
			} // end of for(;;)
		}
		if ( dev != NULL )
			delete dev;
	}
	if ( ret == 0 )
	{
#if	defined(SDBCTL)
		_ftprintf(stderr, TEXT("Drop table %s\n")
		  , this->dbdev.tblname.GetDisplayText()
		);
#endif
		if ( this->dbdev.DropTable(this->dbdev.tblname.GetText()) < 0 )
			ret = -1;
	}
	if ( ret < 0 )
		sqllib->Rollback();
	else
		sqllib->Commit();

	return 0;
}

