//////////////////////////////////////////////////////////////////////////
//	"sdbhttp.cpp"
//------------------------------------------------------------------------
//	$Id: sdbhttp.cpp 98 2006-04-19 06:09:44Z taro $
//////////////////////////////////////////////////////////////////////////

#include	<sdbhttp.h>
#include	<string.h>
#include	"../lib/tform.h"

#if	defined(WIN32)
# include	<crtdbg.h>
#else
# include	<time.h>
#endif

#if	defined(_DEBUG) && defined(WIN32)
#	define	DBGREPORT(param_)	_CrtDbgReport param_
#else
#	define	DBGREPORT(param_)
# ifndef	_ASSERT
#	define	_ASSERT
# endif
#endif

#define	SDB_HTTP_TIMEOUT	5000

#define	HTTP_EOL		"\r\n"
#define	HTTP_VAR_DELIM	"&"

SdbHttp::SdbHttp()
{
	this->authType = AUTHTYPE_UNDECIDED;
	return;
}

SdbHttp::~SdbHttp()
{
	this->smtlist.clear();
	return;
}

int		SdbHttp::SetDevData(sdb::DBDevData & devdata)
{
	this->devdata = devdata;
	return 0;
}

int		SdbHttp::AddSmtData(sdb::DBSmtData & smtdata)
{
	this->smtlist.push_back(smtdata);
	return 0;
}

int		SdbHttp::PostUpdate(void)
{
	VarBuffer			postdata;
	int					retcode = 0;

	DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"SdbHttp::PosUpdate()\n"));
	if ( this->host.GetLength() == 0
	  || this->port.GetLength() == 0 
	  || this->path.GetLength() == 0 )
	{
		DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"host/port/path error\n"));
		return -1;
	}
	if ( this->devdata.dev_model.GetLength() == 0
	  || this->devdata.dev_serial.GetLength() == 0 
	  || this->smtlist.size() == 0 )
	{
		DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"device/smart data error\n"));
		return -1;
	}

	// POSTf[^쐬
	{
		SmtList::iterator	it;
		sdb::DBSmtData		smtdata;
		BOOL				ts_flag = FALSE;

		postdata.Clear();
		postdata.AddText(TEXT("cmd=update"));
		postdata.AddText(TEXT(HTTP_VAR_DELIM"dev_model="));
		this->HtmlRawEncode(postdata, devdata.dev_model.GetText());

		postdata.AddText(TEXT(HTTP_VAR_DELIM"dev_serial="));
		this->HtmlRawEncode(postdata, devdata.dev_serial.GetText());

		if ( this->devdata.dev_user_pass.GetLength() > 0 )
		{
			postdata.AddText(TEXT(HTTP_VAR_DELIM"dev_user_pass="));
			this->HtmlRawEncode(postdata, devdata.dev_user_pass.GetText());
		}

		postdata.AddText(TEXT(HTTP_VAR_DELIM"smt_ts="));
		this->HtmlTimeStampEncode(postdata, (*(this->smtlist.begin())).smt_ts);

		for ( it = this->smtlist.begin(); it != this->smtlist.end(); it++ )
		{
			TCHAR	tmp[256];

			smtdata = *it;
			TForm::SPrintf(tmp, TEXT(HTTP_VAR_DELIM"smt_value%u=%u"HTTP_VAR_DELIM"smt_worst%u=%u"HTTP_VAR_DELIM"smt_threshold%u=%u")
			  , smtdata.smt_attr_id, smtdata.smt_value
			  , smtdata.smt_attr_id, smtdata.smt_worst
			  , smtdata.smt_attr_id, smtdata.smt_threshold
			);
			postdata.AddText(tmp);

			TForm::SPrintf(tmp, TEXT(HTTP_VAR_DELIM"smt_raw_value%u=%I64u"HTTP_VAR_DELIM"smt_raw_data%u=%I64u")
			  , smtdata.smt_attr_id, (TForm::Int64)smtdata.smt_raw_value
			  , smtdata.smt_attr_id, (TForm::Int64)sdb::ATA_GET48(smtdata.smt_raw_data)
			);
			postdata.AddText(tmp);
		}
		postdata.AddChar(0);
	}
	if ( this->PostData(postdata.GetLength(), postdata.GetText()) < 0 )
		return -1;

	return retcode;
}

int		SdbHttp::PostAddDevice(sdb::DBDevData & devdata)
{
	VarBuffer			postdata;
	int					retcode = 0;

	DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"SdbHttp::PosAddDevice()\n"));
	if ( this->host.GetLength() == 0
	  || this->port.GetLength() == 0 
	  || this->path.GetLength() == 0 )
	{
		DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"host/port/path error\n"));
		return -1;
	}
	if ( devdata.dev_model.GetLength() == 0
	  || devdata.dev_serial.GetLength() == 0 )
	{
		DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"device/smart data error\n"));
		return -1;
	}

	// POSTf[^쐬
	{
		TCHAR				tmp[256];

		postdata.Clear();
		postdata.AddText(TEXT("cmd=add"));
		postdata.AddText(TEXT(HTTP_VAR_DELIM"dev_model="));
		this->HtmlRawEncode(postdata, devdata.dev_model.GetText());

		postdata.AddText(TEXT(HTTP_VAR_DELIM"dev_serial="));
		this->HtmlRawEncode(postdata, devdata.dev_serial.GetText());

		postdata.AddText(TEXT(HTTP_VAR_DELIM"dev_hostname="));
		this->HtmlRawEncode(postdata, devdata.dev_hostname.GetText());

		postdata.AddText(TEXT(HTTP_VAR_DELIM"dev_groupname="));
		this->HtmlRawEncode(postdata, devdata.dev_groupname.GetText());

		TForm::SPrintf(tmp, TEXT(HTTP_VAR_DELIM"dev_blocksize=%u"HTTP_VAR_DELIM"dev_blocknumber=%I64u")
		  , devdata.dev_blockSize, (TForm::Int64)devdata.dev_blockNumber
		);
		postdata.AddText(tmp);

		postdata.AddText(TEXT(HTTP_VAR_DELIM"dev_ts_begin="));
		this->HtmlTimeStampEncode(postdata, devdata.dev_ts_begin);

		postdata.AddText(TEXT(HTTP_VAR_DELIM"dev_ts_last="));
		this->HtmlTimeStampEncode(postdata, devdata.dev_ts_last);

		TForm::SPrintf(tmp, TEXT(HTTP_VAR_DELIM"dev_user_stt=%u"HTTP_VAR_DELIM"dev_user_id=%u")
		  , devdata.dev_user_stt, devdata.dev_user_id
		);
		postdata.AddText(tmp);

		postdata.AddText(TEXT(HTTP_VAR_DELIM"dev_user_pass="));
		this->HtmlRawEncode(postdata, devdata.dev_user_pass.GetText());

		postdata.AddText(TEXT(HTTP_VAR_DELIM"dev_user_ts="));
		this->HtmlTimeStampEncode(postdata, devdata.dev_user_ts);

		postdata.AddText(TEXT(HTTP_VAR_DELIM"dev_memo="));
		this->HtmlRawEncode(postdata, devdata.dev_memo.GetText());

		postdata.AddChar(0);
	}
	if ( this->PostData(postdata.GetLength(), postdata.GetText()) < 0 )
		return -1;

	return retcode;
}

int		SdbHttp::PostData(unsigned postsize, const TCHAR * postdata)
{
	SockLib::SockAddr	saddr;
	int					retcode = 0;

	if ( postsize == 0 || postdata == NULL )
		return -1;

	if ( this->Create(SOCK_STREAM) < 0 )
		return -1;
	{
		int		tm;

		tm = SDB_HTTP_TIMEOUT;
		this->SetSockOpt(SOL_SOCKET, SO_SNDTIMEO, &tm, sizeof(tm));
		this->SetSockOpt(SOL_SOCKET, SO_RCVTIMEO, &tm, sizeof(tm));
	}
	try
	{
		VarBuffer	vbuf;

		saddr.sockaddr.sin_family = AF_INET;
		if ( saddr.SetAddr(host.GetText()) < 0 /*|| saddr.sockaddr.sin_addr.S_un.S_addr == 0*/ )
		{
			DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"Address error!\n"));
			throw -1;
		}
		saddr.SetPort(_ttoi(port.GetText()));
		if ( this->Connect(saddr) < 0 )
		{
			DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"Connect error!\n"));
			throw -1;
		}
		{
			vbuf.Clear();
			vbuf.AddText(TEXT("POST "));
			vbuf.AddText(this->path.GetText());
			vbuf.AddText(TEXT(" HTTP/1.0"HTTP_EOL));
			vbuf.AddChar(0);
			this->SendData(vbuf.GetLength(), vbuf.GetText());
		}

		if ( this->authType != AUTHTYPE_UNDECIDED && this->authType != AUTHTYPE_NONE )
		{
			VarBuffer	codesrc, codedst;

			if ( this->authUser.GetLength() > 0 )
				codesrc.AddText(this->authUser.GetText());
			codesrc.AddText(TEXT(":"));
			if ( this->authPass.GetLength() > 0 )
				codesrc.AddText(this->authPass.GetText());
			codesrc.AddChar(0);

			vbuf.Clear();
			switch ( this->authType )
			{
			case AUTHTYPE_BASIC:
			{
				VarBuffer::Base64Encode(codesrc.GetLength(), codesrc.GetText(), codedst);
				codedst.AddChar(0);
				this->SendData(vbuf.GetLength(), vbuf.GetText());
				vbuf.AddText("Authorization: Basic ");
				vbuf.AddText(codedst.GetText());
				vbuf.AddText(TEXT(HTTP_EOL));
				vbuf.AddChar(0);
				DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"Basic Auth: %s!\n", vbuf.GetText()));
				break;
			}
			default:
				DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"Unknown AuthType %d!\n", (int)this->authType));
				throw -1;
			}
			this->SendData(vbuf.GetLength(), vbuf.GetText());
		}

		{
			vbuf.Clear();
			vbuf.AddText(TEXT("Content-type: application/x-www-form-urlencoded"HTTP_EOL));
			vbuf.AddChar(0);
			this->SendData(vbuf.GetLength(), vbuf.GetText());
		}
		{
			TCHAR	tmp[80];

			_stprintf(tmp, TEXT("Content-length: %u"HTTP_EOL), postsize);
			this->SendData((unsigned)_tcslen(tmp), tmp);
		}

		// s
		vbuf.Clear();
		vbuf.AddText(TEXT(HTTP_EOL));
		vbuf.AddChar(0);
		this->SendData(vbuf.GetLength(), vbuf.GetText());

		// POSTf[^
		this->SendData(postsize, postdata);
		this->SendData(vbuf.GetLength(), vbuf.GetText());	// s

		// s
	//	this->SendData(vbuf.GetLength(), vbuf.GetText());

		// M
		vbuf.Clear();
		this->RecvData(vbuf);
		if ( vbuf.GetLength() > 0 && vbuf.GetText() != NULL )
		{
			VarBuffer	lbuf, word;

#if	defined(SDBCTL) && defined(_DEBUG)
//			_fputts(vbuf.GetText(), stdout);
#endif
			vbuf.SetBuffer();
			this->recvdata.TransferToBuffer((vbuf.GetLength() + 1) * sizeof(TCHAR), vbuf.GetText(), vbuf.GetLength());
			this->rescode = 0;
			while ( vbuf.GetLine(lbuf) > 0 )
			{
			//	_fputts(lbuf.GetText(), stdout); _fputts(TEXT("\n"), stdout);
				word.Clear();
				lbuf.SetBuffer();
				lbuf.GetWord(word);
				if ( this->rescode == 0 )
				{
					if ( SQStr::StrCmpi(word.GetText(), TEXT("HTTP"), 4) == 0 )
					{
						int		ch;

						for (;;)
						{
							if ( (ch = lbuf.GetChar()) <= 0 )
								break;
							if ( ch == TEXT(' ') )
							{
								word.Clear();
								if ( lbuf.GetWord(word) > 0 )
								{
									this->rescode = _ttoi(word.GetText());
									break;
								}
							}
						}
					}
				}
			} // end of while
			if ( this->rescode > 0 )
			{
				_ftprintf(stdout, TEXT("Found HTTP Result %d\n"), this->rescode);
				DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"Found HTTP Result. (%s)\n", lbuf.GetText()));
			}
		}

		retcode = 0;
	} catch(int ret) { retcode = ret; }
	this->Close();

	return retcode;
}

int		SdbHttp::SendData(unsigned size, const TCHAR * buffer)
{
	int				ret, result = 0;
	const TCHAR		*send_ptr = buffer;
	unsigned		send_size = 0, send_remain = size;

	DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"SdbHttp::SendData()\n"));
#if	defined(SDBCTL) && defined(_DEBUG)
	fwrite(buffer, size, 1, stdout);
#endif
	while ( send_remain > 0 )
	{
		ret = this->Send(send_remain, send_ptr, 0);
		if ( ret > 0 )
		{
			send_size += ret;
			send_ptr += ret;
			if ( ret > (int)send_remain )
				ret = send_remain;
			send_remain -= ret;
		} else
		{	// error
			result = -1;
			break;
		}
	}
	return (int)send_size;
}

int		SdbHttp::RecvData(VarBuffer & vbuf)
{
	unsigned	recv_size = 0;

	DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"SdbHttp::RecvData()\n"));
	for (;;)
	{
		BYTE	buffer[4096];
		int		recv_res;

		recv_res = this->Recv(sizeof(buffer), buffer, 0);
		if ( recv_res <= 0 )
			break;
		vbuf.Add(recv_res, buffer);
		recv_size += recv_res;
	}
	vbuf.AddChar(0);
	return (int)recv_size;
}

int		SdbHttp::HtmlTimeStampEncode(VarBuffer & wbuf, SqlLib::TimeStamp & ts) // static
{
	TCHAR	tmp[80];

	_stprintf(tmp, TEXT("%04u-%02u-%02u %02u:%02u:%02u")
	  , ts.year
	  , ts.month
	  , ts.day
	  , ts.hour
	  , ts.minute
	  , ts.second
	);
	return SdbHttp::HtmlRawEncode(wbuf, tmp);
}

int		SdbHttp::HtmlRawEncode(VarBuffer & wbuf, const TCHAR * src) // static
{
	int		ch, len = 0;
	SQStr	str;
	void	*p;

	str = src;
	p = str.GetPtrTop();
	while( (ch = str.GetPtrChar(p)) > 0 )
	{
		if ( (ch >= TEXT('A') && ch <= TEXT('Z')) || (ch >= TEXT('a') && ch <= TEXT('z')) 
		  || (ch >= TEXT('0') && ch <= TEXT('9')) )
		{
			wbuf.AddChar(ch);
			len++;
		}  else if ( ch < 256 )
		{
			TCHAR		tmp[32];
			unsigned	size;

			_stprintf(tmp, TEXT("%%%02x"), ch);
			size = (unsigned)_tcslen(tmp);
			wbuf.Add(size, tmp);
			len += size;
		} else
		{
			TCHAR		tmp[32];
			unsigned	size;

			_stprintf(tmp, TEXT("%%%02x%%%02x"), (ch>>8) & 0xFF, ch & 0xFF);
			size = (unsigned)_tcslen(tmp);
			wbuf.Add(size, tmp);
			len += size;
		}
		p = str.GetPtrNext(p);
	}
	return len;
}


SdbHttp::AuthType	SdbHttp::GetAuthType(const TCHAR * name) // static
{
	SdbHttp::AuthType	authtype = AUTHTYPE_NONE;

	if ( name != NULL )
	{
		if ( _tcsicmp(name, TEXT("basic")) == 0 )
			authtype = AUTHTYPE_BASIC;
	}
	return authtype;
}
