//////////////////////////////////////////////////////////////////////////
//	"scsihead.h"
//------------------------------------------------------------------------
//	$Id: scsihead.h 4 2006-03-01 22:26:13Z taro $
//////////////////////////////////////////////////////////////////////////
#ifndef	SCSIHEAD_H_INCLUDED
#define	SCSIHEAD_H_INCLUDED

#if	defined(LINUX)
#	include	"../linux/defs.h"
#endif
#if	defined(WIN32)
#	include	<windows.h>
#endif
#if	!defined(ATTB_PACKED)
# if	defined(LINUX)
#   define	ATTB_PACKED	__attribute ((packed))
# endif
# if	defined(WIN32)
#   define	ATTB_PACKED
# endif
#endif

#define	SCSI_GET32(p)	(((DWORD)((BYTE *)(p))[0]<<24)+((DWORD)((BYTE *)(p))[1]<<16)+((DWORD)((BYTE *)(p))[2]<<8)+((DWORD)((BYTE *)(p))[3]))
#define	SCSI_GET24(p)	(((DWORD)((BYTE *)(p))[0]<<16)+((DWORD)((BYTE *)(p))[1]<<8)+((DWORD)((BYTE *)(p))[2]))
#define	SCSI_GET16(p)	((WORD)(((BYTE *)(p))[0]<<8)+((WORD)((BYTE *)(p))[1]))
#define	SCSI_GET8(p)	(((BYTE *)(p))[0])

#define	SCSI_PUT32(p,u)	{ ((BYTE *)(p))[0]=(BYTE)((u)>>24); ((BYTE *)(p))[1]=(BYTE)((u)>>16); ((BYTE *)(p))[2]=(BYTE)((u)>>8); ((BYTE *)(p))[3]=(BYTE)(u); }
#define	SCSI_PUT24(p,u)	{ ((BYTE *)(p))[0]=(BYTE)((u)>>16); ((BYTE *)(p))[1]=(BYTE)((u)>>8); ((BYTE *)(p))[2]=(BYTE)(u); }
#define	SCSI_PUT16(p,u)	{ ((BYTE *)(p))[0]=(BYTE)((u)>>8); ((BYTE *)(p))[1]=(BYTE)(u); }
#define	SCSI_PUT8(p,u)	{ ((BYTE *)(p))[0]=(BYTE)(u); }

#if	defined(_MSC_VER)
#	pragma pack(push,1)
#endif

struct SCSIINQUIRY
{
	unsigned char		deviceType: 5;			// + 0
	unsigned char		qualifier : 3;
	unsigned char		devTypeModifier : 7;	// + 1	// Reserved
	unsigned char		removable       : 1;
	unsigned char		ansiVer : 3;			// + 2
	unsigned char		ecmaVer : 3;
	unsigned char		isoVer  : 2;
	unsigned char		dataFormat        : 4;	// + 3
	unsigned char		hierarchical      : 1;
	unsigned char		normalACA         : 1;
	unsigned char		terminateIOProcess: 1;			// Obsolete
	unsigned char		aenc              : 1;			// Obsolete
	BYTE				dataLength;				// + 4
	unsigned char		protect : 1;			// + 5
	unsigned char		rsv5    : 2;
	unsigned char		thirdPartyCopy: 1;
	unsigned char		alua          : 2;				// asymmetric logical unit access
	unsigned char		acc           : 1;				// Access Controls Coordinator
	unsigned char		sccs          : 1;				// SCC Suported
	unsigned char		addr16 : 1;				// + 6
	unsigned char		obs6_1          : 1;
	unsigned char		obs6_2          : 1;
	unsigned char		mediumChanger   : 1;
	unsigned char		multiPort       : 1;
	unsigned char		osb6_5          : 1;
	unsigned char		enclosureService: 1;
	unsigned char		bque            : 1;
	unsigned char		softReset      : 1;		// + 7
	unsigned char		commandQueuing : 1;
	unsigned char		rsv7           : 1;
	unsigned char		linked         : 1;
	unsigned char		sync           : 1;
	unsigned char		wideBus16      : 1;
	unsigned char		wideBus32      : 1;
	unsigned char		relativeAddress: 1;
	BYTE				venderId[8];			// + 8
	BYTE				productId[16];			// +16
	BYTE				productVersion[4];		// +32
	BYTE				dummy[4];				// +36
} ATTB_PACKED;

struct SCSICAPACITYDATA
{
	BYTE				logicalBlockAddress[4];
	BYTE				blockLength[4];
} ATTB_PACKED;

struct SCSI_VPD_PAGECODE_LIST
{
	BYTE				descTypeCode;
	BYTE				pagecode;
	BYTE				rsv3;
	BYTE				pagelen;
} ATTB_PACKED;

struct SCSI_MODE_PARAMETER_HEADER6
{
	BYTE				length;
	BYTE				mediumType;
	BYTE				devSpcParam;
	BYTE				blkDescLen;
};

struct SCSI_MODE_PARAMETER_HEADER10
{
	BYTE				length[2];
	BYTE				mediumType;
	BYTE				devSpcParam;
	unsigned char		longlba : 1;
	unsigned char		rsv4    : 7;
	BYTE				rsv5;
	BYTE				blkDescLen[2];
} ATTB_PACKED;

struct SCSITOCDATA
{
	BYTE				tocLength[2];
	BYTE				startTrack;
	BYTE				lastTrack;
	struct tagTrack
	{
		BYTE			dummy0;
		BYTE			adrctl;
		BYTE			no;
		BYTE			dummy1;
		BYTE			cdAddr[4];
	} track[100];
} ATTB_PACKED;

struct ScsiPagecode02_Drm		// 0x02 Disconect-Reconnect mode page
{
	unsigned char		pagecde : 6;			// + 0
	unsigned char		spf     : 1;
	unsigned char		ps      : 1;
	BYTE				length;					// + 1
	BYTE				buf_full_ratio;			// + 2
	BYTE				buf_empty_ratio;		// + 3
	BYTE				bus_inact_limit[2];		// + 4
	BYTE				disconn_timelimit[2];	// + 6
	BYTE				connect_timelimit[2];	// + 8
	BYTE				max_burst_size[2];		// +10
	unsigned char		dtdc            : 3;	// + 12 data transfer disconnect control
	unsigned char		dimm            : 1;	// disconnect immediate
	unsigned char		fair_arbitration: 3;	// 
	unsigned char		emdp            : 1;	// enable modify data pointers
	BYTE				rsb13;					// +13
	BYTE				first_burst_size[2];	// +14
} ATTB_PACKED;

struct ScsiPagecode05_Fdm		// 0x05 Flexible Disk Mode page
{
	unsigned char		pagecde : 6;			// + 0
	unsigned char		spf     : 1;
	unsigned char		ps      : 1;
	BYTE				length;					// + 1
	BYTE				transfer_rate[2];		// + 2
	BYTE				heads;					// + 4 number of heads
	BYTE				sectors;				// + 5 sectors per track
	BYTE				sector_size[2];			// + 6 data bytes per sector
	BYTE				cylinders[2];			// + 8 number of cylinder
	BYTE				start_cylwrt_precom[2];	// +10
	BYTE				start_cylrdu_wrtcrt[2];	// +12
	BYTE				dev_step_rate[2];		// +14
	BYTE				dev_step_pluswidth;		// +16
	BYTE				head_settle_delay[2];	// +17
	BYTE				motor_on_delay;			// +19
	BYTE				motor_off_delay;		// +20
	unsigned char		rsv21            : 5;	// +21
	unsigned char		motor_on         : 1;	//
	unsigned char		start_sec_num    : 1;	//
	unsigned char		true_ready       : 1;	//
	unsigned char		step_plus_per_cyl: 4;	// + 22
	unsigned char		rsv22            : 4;
	BYTE				write_compensation;		// +23
	BYTE				head_load_delay;		// +24
	BYTE				head_unload_delay;		// +25
	unsigned char		pin2             : 4;	// +26
	unsigned char		pin34            : 4;	// 
	unsigned char		pin1             : 4;	// +27
	unsigned char		pin4             : 4;	// 
	BYTE				medium_rot_rate[2];		// +28
	BYTE				rsv30[2];				// +30
} ATTB_PACKED;


struct ScsiPagecode0A_Cmp		// 0x0A Control Mode Page
{
	unsigned char		pagcode       : 6;	// +0
	unsigned char		spf           : 1;
	unsigned char		ps            : 1;
	BYTE				length;				// + 1
	unsigned char		rlec          : 1;	// + 2
	unsigned char		gltsd         : 1;
	unsigned char		d_sense       : 1;
	unsigned char		rsb2          : 2;
	unsigned char		task_set_type : 3;
	unsigned char		disable_que   : 1;	// +3	(Obsolete
	unsigned char		queue_err_man : 2;
	unsigned char		rsv3          : 1;
	unsigned char		queue_alg_mod : 4;
	unsigned char		error_aen_perm: 1;	// +4	(Obsolete
	unsigned char		unit_aaen_perm: 1;	//		(Obsolete
	unsigned char		ready_aen_perm: 1;	//		(Obsolete
	unsigned char		write_protect : 1;
	unsigned char		ua_intlck_ctrl: 2;
	unsigned char		report_check  : 1;
	unsigned char		task_abort_stt: 1;
	unsigned char		autoload_mode : 3;	// + 5
	unsigned char		rsv5          : 4;
	unsigned char		app_tag_owner : 1;
	BYTE				ready_aen_hoff[2];	// + 6	(Obsolete
	BYTE				busy_timeout[2];	// + 8
	BYTE				ext_stest_time[2];	// +10
} ATTB_PACKED;

struct ScsiPagecode2A_Mms
{
	unsigned char		pagecde : 6;	// + 0
	unsigned char		spf     : 1;
	unsigned char		ps      : 1;
	BYTE				length;			// + 1
	struct tag_read						// + 2
	{
		unsigned char	cdr     : 1;
		unsigned char	cdrw    : 1;
		unsigned char	method2 : 1;
		unsigned char	dvdrom  : 1;
		unsigned char	dvdr    : 1;
		unsigned char	dvdram  : 1;
		unsigned char	rsv02   : 2;
	} rd;
	struct tag_write					// + 3
	{
		unsigned char	cdr     : 1;
		unsigned char	cdrrw   : 1;
		unsigned char	test    : 1;
		unsigned char	rsv03   : 1;
		unsigned char	dvdr    : 1;
		unsigned char	dvdram  : 1;
		unsigned char	rsv03_1 : 2;
	} wr;
	unsigned char		audio_play      : 1;	// + 4
	unsigned char		composite       : 1;
	unsigned char		digital_port1   : 1;
	unsigned char		digital_port2   : 1;
	unsigned char		mode2_from1     : 1;
	unsigned char		mode2_from2     : 1;
	unsigned char		multi_session   : 1;
	unsigned char		buf             : 1;
	unsigned char		cdda_cmd        : 1;	// + 5
	unsigned char		cdda_stream_acc : 1;
	unsigned char		rw_supported    : 1;
	unsigned char		rw_deinterleaved: 1;
	unsigned char		c2_pointer      : 1;
	unsigned char		isrc            : 1;
	unsigned char		upc             : 1;
	unsigned char		read_bar_code   : 1;
	unsigned char		lock            : 1;	// + 6
	unsigned char		lock_status     : 1;
	unsigned char		prevend_jumper  : 1;
	unsigned char		eject           : 1;
	unsigned char		rsv06           : 1;
	unsigned char		loading_type    : 3;
	unsigned char		sep_vol_level   : 1;	// + 7
	unsigned char		sep_ch_mute     : 1;
	unsigned char		changer_support : 1;
	unsigned char		sss             : 1;
	unsigned char		side_change_capa: 1;
	unsigned char		rw_in_lead_in   : 1;
	unsigned char		rsv07           : 2;
	BYTE				max_read[2];			// + 8	(Obsolete
	BYTE				vol_level[2];			// +10
	BYTE				buf_size[2];			// +12
	BYTE				cur_read[2];			// +14	(Obsolete
	BYTE				rsv16;					// +16
	unsigned char		rsv17           : 1;	// +17
	unsigned char		bckf            : 1;
	unsigned char		rck             : 1;
	unsigned char		lsbf            : 1;
	unsigned char		desc_bit_length : 2;
	unsigned char		rsv17_1         : 2;
	BYTE				max_write[2];			// +18	(Obsolete
	BYTE				cur_write[2];			// +20	(Obsolete
	BYTE				copy_man_rev[2];		// +22
	BYTE				rsv24[3];				// +24
	unsigned char		rotation_ctrl   : 2;	// +27
	unsigned char		rsv27           : 6;
	BYTE				cur_write_sel[2];		// 28
	BYTE				num_desc_tbl[2];		// 30
} ATTB_PACKED;

struct ScsiDvdStrFormat0000_Pfi
{
	unsigned char	part_version  : 4;	// + 0
	unsigned char	book_type     : 4;
	unsigned char	max_rate      : 4;	// + 1
	unsigned char	disc_size     : 3;
	unsigned char	rsv01         : 1;
	unsigned char	layer_type    : 4;	// + 2
	unsigned char	track_path    : 1;
	unsigned char	num_layer     : 2;
	unsigned char	rsv02         : 1;
	unsigned char	track_density : 4;	// + 3
	unsigned char	linear_density: 4;
	BYTE			zero_04;			// + 4
	BYTE			start_sec_data[3];
	BYTE			zero_08;
	BYTE			end_sec_data[3];
	BYTE			zero_12;
	BYTE			end_sec_layer[3];
	unsigned char	rsv15         : 7;	// +16
	unsigned char	bca           : 1;
} ATTB_PACKED;

struct ScsiDvdStrFomrta000E_Pil
{
	BYTE			filed_id0;			// + 0
	BYTE			disc_appl_code;		// + 1
	BYTE			disc_phy_code;		// + 2
	BYTE			last_addr[3];		// + 3
	unsigned char	ext_code      : 4;	// + 6
	unsigned char	part_version  : 4;
	BYTE			rsb07;				// + 7
	BYTE			filed_id8;			// + 8
	BYTE			opc_sug_code;		// + 9
	BYTE			wavelen_opc_code;	// +10
	BYTE			white_str_code[4];	// +11
	BYTE			rsb15;				// +15
	BYTE			filed_id16;			// +16
	BYTE			manufacturer_id[6];	// +17
	BYTE			rsb23;				// +23
	BYTE			filed_id24;			// +24
	BYTE			manufacturer_id2[6];// +17
	BYTE			rsb31;				// +31
	BYTE			filed_id32;			// +32
//	BYTE			manufacturer_id3[6];// +33
//	BYTE			filed_id39;			// +39
} ATTB_PACKED;


#if	defined(_MSC_VER)
#	pragma pack(pop)
#endif

#endif
